/*
This sample program shows how to browse an array of objects
using the OBJECTVAR clause of DCBROWSECOL.
*/

#include "dcdialog.ch"
#INCLUDE "appevent.CH"

FUNCTION Main()

LOCAL oData, aData1[0], aData2[0], GetList[0], oBrowse1, oBrowse2, ;
      oBrowse3, GetOptions, oRecord, i, nRecNo, lStatus, nPointer := 1, ;
      aData3[0], oTab1, oTab2, oTab3, oRecord2, cSeek1 := Space(15), ;
      bScan1, cSeek2 := Space(15), bScan2

DC_LoadRdds()

PUBLIC aData := aData1

USE ..\..\data\customer VIA 'FOXCDX'

oRecord := CUSTOMER->(DC_DbRecord():new())

DO WHILE !CUSTOMER->(Eof())
  oRecord := CUSTOMER->(DC_DbRecord():new())
  CUSTOMER->(DC_DbScatter(oRecord))
  AAdd(aData1,{oRecord,CUSTOMER->(RecNo())})
  AAdd(aData2,oRecord)
  AAdd(aData3,(Scatter()))
  CUSTOMER->(dbSkip())
ENDDO

ASort(aData1,,,{|a,b|Upper(a[1]:cust_nmbr) < Upper(b[1]:cust_nmbr)})
ASort(aData2,,,{|a,b|a:cust_nmbr < b:cust_nmbr})
bScan1 := {|a|a[1]:cust_nmbr=Trim(cSeek1)}
bScan2 := {|o|o:cust_nmbr=Trim(cSeek2)}

@ 0,0 DCTABPAGE oTab1 CAPTION 'Browse 1' SIZE 100,20

// Browsing a multi-dimensional array with objects
@ 2,2 DCSAY 'This is a \i\ubrowse\c of a \bmulti-dimensional\c array of objects:\n' FORMATTED ;
      SAYSIZE 0 FONT '10.Lucida Console' ;
      RESIZE DCGUI_RESIZE_REPOSONLY_Y ;
      PARENT oTab1

@ 3,2 DCSAY 'Find' GET cSeek1 ;
      KEYBLOCK {|a,b,o|DC_BrowseAutoSeek(a,o,oBrowse1,aData1,,,,,,,,,bScan1)} ;
      SAYSIZE 0 SAYBOTTOM PARENT oTab1

@ 4,2 DCBROWSE oBrowse1 DATA aData1 SIZE 20,15 FIT ;
     ;// FILTER {|a|Left(a[1]:bill_city,1)$'ASWBGH'} ;
      POINTER nPointer ;
      NOHSCROLL ;
      RESIZE DCGUI_RESIZE_RESIZEONLY ;
;//      EDIT xbeBRW_ItemSelected ;
      ITEMSELECTED {||EditRecord(aData1[nPointer,1]),oBrowse1:refreshCurrent()} ;
      PARENT oTab1

DCBROWSECOL OBJECTVAR cust_nmbr ELEMENT 1  HEADER 'ID'       WIDTH  5 PARENT oBrowse1 ;
   SORT {||ASort(aData1,,,{|a,b|Upper(a[1]:cust_nmbr) < Upper(b[1]:cust_nmbr)}), ;
           bScan1 := {|a|a[1]:cust_nmbr=Trim(cSeek1)}} DEFAULT

DCBROWSECOL OBJECTVAR {|o|Upper(o:bill_name)} ELEMENT 1  HEADER 'Name' WIDTH 15 PARENT oBrowse1 ;
   SORT {||ASort(aData1,,,{|a,b|Upper(a[1]:bill_name) < Upper(b[1]:bill_name)}), ;
           bScan1 := {|a|Upper(a[1]:bill_name)=Upper(Trim(cSeek1))}}

DCBROWSECOL OBJECTVAR bill_strt ELEMENT 1  HEADER 'Address'  WIDTH 15 PARENT oBrowse1 ;
   SORT {||ASort(aData1,,,{|a,b|Upper(a[1]:bill_strt) < Upper(b[1]:bill_strt)}), ;
           bScan1 := {|a|Upper(a[1]:bill_strt)=Upper(Trim(cSeek1))}}

DCBROWSECOL OBJECTVAR bill_city ELEMENT 1  HEADER 'City'     WIDTH 10 PARENT oBrowse1 ;
   SORT {||ASort(aData1,,,{|a,b|Upper(a[1]:bill_city) < Upper(b[1]:bill_city)}), ;
           bScan1 := {|a|Upper(a[1]:bill_city)=Upper(Trim(cSeek1))}}

DCBROWSECOL OBJECTVAR bill_zip  ELEMENT 1  HEADER 'Zip'      WIDTH  4 PARENT oBrowse1 ;
   SORT {||ASort(aData1,,,{|a,b|Upper(a[1]:bill_zip) < Upper(b[1]:bill_zip)}), ;
           bScan1 := {|a|Upper(a[1]:bill_zip)=Upper(Trim(cSeek1))}}

@ 0,0 DCTABPAGE oTab2 CAPTION 'Browse 2' RELATIVE oTab1

// Browsing a single-dimensional array with objects
@ 2,2 DCSAY 'This is a \i\ubrowse\c of a \bsingle-dimensional\c array of objects:\n' FORMATTED ;
   SAYSIZE 0 FONT '10.Lucida Console' PARENT oTab2 ;
   RESIZE DCGUI_RESIZE_REPOSONLY_Y

@ 3,2 DCSAY 'Find' GET cSeek2 ;
      KEYBLOCK {|a,b,o|DC_BrowseAutoSeek(a,o,oBrowse2,aData2,,,,,,,,,bScan2)} ;
      SAYSIZE 0 SAYBOTTOM PARENT oTab2

@ 4,2 DCBROWSE oBrowse2 DATA aData2 SIZE 20,15 FIT ;
       RESIZE DCGUI_RESIZE_RESIZEONLY_X PARENT oTab2

DCBROWSECOL OBJECTVAR cust_nmbr HEADER 'ID' WIDTH  5 PARENT oBrowse2 ;
   SORT {||ASort(aData2,,,{|a,b|Upper(a:cust_nmbr) < Upper(b:cust_nmbr)}), ;
           bScan2 := {|o|Upper(o:cust_nmbr)=Trim(Upper(cSeek2))}} DEFAULT

DCBROWSECOL OBJECTVAR bill_name HEADER 'Name'     WIDTH 15 PARENT oBrowse2 ;
   SORT {||ASort(aData2,,,{|a,b|Upper(a:bill_name) < Upper(b:bill_name)}), ;
           bScan2 := {|o|Upper(o:bill_name)=Trim(Upper(cSeek2))}}

DCBROWSECOL OBJECTVAR {|o|Upper(Trim(o:bill_strt))} HEADER 'Address' WIDTH 15 PARENT oBrowse2 ;
   SORT {||ASort(aData2,,,{|a,b|Upper(a:bill_strt) < Upper(b:bill_strt)}), ;
           bScan2 := {|o|Upper(o:bill_strt)=Trim(Upper(cSeek2))}}

DCBROWSECOL OBJECTVAR {|o|Trim(o:bill_city)} HEADER 'City' WIDTH 10 PARENT oBrowse2 ;
   SORT {||ASort(aData2,,,{|a,b|Upper(a:bill_city) < Upper(b:bill_city)}), ;
           bScan2 := {|o|Upper(o:bill_city)=Trim(Upper(cSeek2))}}

DCBROWSECOL OBJECTVAR bill_zip  HEADER 'Zip' WIDTH  4 PARENT oBrowse2 ;
   SORT {||ASort(aData2,,,{|a,b|Upper(a:bill_zip) < Upper(b:bill_zip)}), ;
           bScan2 := {|o|Upper(o:bill_zip)=Trim(Upper(cSeek2))}}

@ 0,0 DCTABPAGE oTab3 CAPTION 'Browse 3' RELATIVE oTab2

// Browsing a database array with objects
@ 2,2 DCSAY 'This is a \i\ubrowse\c of a \bdatabase\c with a reference record object:\n' FORMATTED ;
   SAYSIZE 0 FONT '10.Lucida Console' PARENT oTab3

oRecord2 := CUSTOMER->(DC_DbRecord():new())
CUSTOMER->(dbGoTop())

@ 3,2 DCBROWSE oBrowse3 ALIAS 'CUSTOMER' SIZE 20,16 FIT ;
       RESIZE DCGUI_RESIZE_RESIZEONLY_X PARENT oTab3 ;
       RECORDOBJECT oRecord2

DCBROWSECOL DATA {|o|o:cust_nmbr} HEADER 'ID' WIDTH  5 PARENT oBrowse3
DCBROWSECOL DATA {|o|o:bill_name} HEADER 'Name'     WIDTH 15 PARENT oBrowse3
DCBROWSECOL DATA {|o|o:bill_strt} HEADER 'Address'  WIDTH 15 PARENT oBrowse3
DCBROWSECOL DATA {|o|o:bill_city} HEADER 'City'     WIDTH 10 PARENT oBrowse3
DCBROWSECOL DATA {|o|o:bill_zip}  HEADER 'Zip'      WIDTH  4 PARENT oBrowse3
DCBROWSECOL DATA {|o|o:record_number} HEADER 'Record' WIDTH 5 PICTURE '99999' PARENT oBrowse3

@ 21,0 DCPUSHBUTTON CAPTION 'Browse Objects in GetList' SIZE 20 ;
       ACTION {||BrowseGetListObjects(GetList)}

DCGETOPTIONS RESIZE

DCREAD GUI FIT ADDBUTTONS TITLE 'Browse array of objects' TO lStatus ;
   SETAPPWINDOW OPTIONS GetOptions

IF lStatus
  FOR i := 1 TO Len(aData1)
    oRecord := aData1[i,1]
    nRecno := aData1[i,2]
    CUSTOMER->(dbGoTo(nRecno))
    CUSTOMER->(DC_DbGather(oRecord))
  NEXT
ENDIF

RETURN nil

PROC appsys; return

* -----------

STATIC FUNCTION BrowseGetListObjects( aGetList )

LOCAL GetList[0], oBrowse

@ 0,0 DCBROWSE oBrowse DATA aGetList SIZE 20,20 FIT

DCBROWSECOL DATA {||oBrowse:arrayElement} HEADER 'Nmbr' WIDTH 3 PICTURE '9999' PARENT oBrowse

DCBROWSECOL DATA {||DC_GetListType(aGetList[oBrowse:arrayElement,nGETLIST_TYPE])} ;
   HEADER 'Type' WIDTH 15 PARENT oBrowse

DCBROWSECOL DATA {||aGetList[oBrowse:arrayElement,cGETLIST_CAPTION]} ;
   HEADER 'Caption' WIDTH 15 PARENT oBrowse

DCBROWSECOL OBJECTVAR className() ELEMENT oGETLIST_OBJECT ;
   HEADER 'Class Name' WIDTH 10 PARENT oBrowse

DCBROWSECOL OBJECTVAR setParent() ELEMENT oGETLIST_OBJECT ;
   HEADER 'Parent' WIDTH 10 PARENT oBrowse

DCBROWSECOL OBJECTVAR currentSize()[1] ELEMENT oGETLIST_OBJECT ;
   HEADER 'Width' WIDTH 3 PARENT oBrowse PICTURE '9999'

DCBROWSECOL OBJECTVAR currentSize()[2] ELEMENT oGETLIST_OBJECT ;
   HEADER 'Height' WIDTH 3 PARENT oBrowse PICTURE '9999'

DCBROWSECOL OBJECTVAR currentPos()[1] ELEMENT oGETLIST_OBJECT ;
   HEADER 'Col' WIDTH 3 PARENT oBrowse PICTURE '9999'

DCBROWSECOL OBJECTVAR currentPos()[2] ELEMENT oGETLIST_OBJECT ;
   HEADER 'Row' WIDTH 3 PARENT oBrowse PICTURE '9999'

DCBROWSECOL OBJECTVAR setFontCompoundName() ELEMENT oGETLIST_OBJECT ;
   HEADER 'Font' WIDTH 15 PARENT oBrowse



DCREAD GUI FIT TITLE 'Browsing GetList' MODAL

RETURN nil

* ------------

FUNCTION EditRecord( oRecord )

LOCAL GetList[0], lStatus

@ 0,0 DCSAY 'Billing Name' GET oRecord:bill_name
@ 1,0 DCSAY 'Billing Street' GET oRecord:bill_strt

DCREAD GUI FIT TITLE 'Editing Data' ADDBUTTONS ENTEREXIT TO lStatus

IF lStatus
  CUSTOMER->(DC_DbGather(oRecord))
ENDIF

RETURN nil

