/*
 ķ
   Program..: _DCFINDX.PRG                                     
   Author...: Roger J. Donnay                                  
   Date.....: Jan 1, 2002                                      
   Notes....: DC_FindBrowse(), DC_BrowseAutoSeek()             
 Ľ
*/

#INCLUDE "dcdialog.CH"
#INCLUDE "appevent.CH"
#include "class.ch"
#INCLUDE "gra.CH"
#INCLUDE "dcmsg.CH"
#INCLUDE "dcbitmap.CH"

FUNCTION DC_FindBrowse( aFields, oParent, nRow, nCol, nWidth, nHeight, cTitle, ;
                        lAutoSeek, lHeaders, lPixel, acbData, nPointer, bEval, ;
                        aPres, lHorizScroll, lVertScroll, lExit, nDelay, ;
                        cFont, lLeftButton, bPopUp, aSort, aGetList, ;
                        bItemSelected, bItemMarked, cSayIndexFont, nKey, oGet, ;
                        lClearEvents )

LOCAL GetList := {}, cSeek, cAlias, aData[5], bSort, lThumbLock, ;
      i, oSeekSay, lOk, nSaveRec := -1, nSaveOrder := -1, nHeadLines, ;
      cPrompt := '', GetOptions, xData, nColumn := 0, aPresentation, ;
      aHeaderColors, cPrefix := '', bFormat, lScope := !Empty(DC_SetScope(0)), ;
      aTokens, nElement, bSeek, nDataSourceType

DEFAULT nRow := 1, ;
        nCol := 1, ;
        nWidth := 60, ;
        nHeight := 10, ;
        cTitle := "Find a Record", ;
        lAutoSeek := .t., ;
        lHeaders := .t., ;
        lPixel := .f., ;
        nPointer := 1, ;
        bEval := {||nil}, ;
        lVertScroll := .t., ;
        lHorizScroll := .t., ;
        lExit := .f., ;
        lLeftButton := .f., ;
        cSayIndexFont := '8.Courier', ;
        aSort := DC_FindBrowseSort(), ;
        bItemSelected := {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)}, ;
        lClearEvents := .f.

ASize(aSort,9)
DEFAULT aSort[9] := GRA_CLR_RED

IF Valtype(acbData) = 'B'
  xData := Eval(acbData)
ELSEIF Valtype(acbData) $ 'ACO'                        // J. Duijf 27-11-2002
  xData := acbData
ELSE
  xData := Alias()
ENDIF

lThumbLock := .f.
IF Valtype(xData) = 'C'
  nDataSourceType     := BROWSE_DATABASE               // J. Duijf 27-11-2002
  lThumbLock         := !Empty((xData)->(dbFilter()))
  nSaveOrder         := (xData)->(IndexOrd())         // J. Duijf 27-11-2002
  nSaveRec           := (xData)->(RecNo())            // J. Duijf 27-11-2002
ELSEIF Valtype(xData) = "O"
  if xData:isDerivedFrom("SQLStatement")              // J. Duijf 27-11-2002
     nDataSourceType  := BROWSE_DATABASE               // J. Duijf 27-11-2002
  elseif xData:isDerivedFrom("SQLDataSet")             // Sql-express
     nDataSourceType  := BROWSE_SQLEXPRESS
  else
     nDataSourceType  := BROWSE_DATAOBJECT             // J. Duijf 27-11-2002
     nSaveOrder      := xData:IndexOrd()              // J. Duijf 27-11-2002
     nSaveRec        := xData:RecNo()                 // J. Duijf 27-11-2002
  endif
  lThumbLock := !Empty(xData:dbFilter())
ENDIF
/*                                                    // J. Duijf 27-11-2002
IF !Empty(Alias())
  nSaveOrder := IndexOrd()
  nSaveRec := RecNo()
ENDIF
*/
nHeadLines := 1

FOR i := 1 TO Len(aFields)
  IF Valtype(aFields[i,2]) = 'C'                         // header
    aTokens := DC_TokenArray(aFields[i,2],';')
    nHeadLines := Max(nHeadLines,Len(aTokens))
  ENDIF
  IF Valtype(aFields[i,1]) = 'B' .AND. Valtype(aFields[i,4]) = 'C'
      if nDataSourceType = BROWSE_DATABASE               // J. Duijf 27-11-2002
         if Upper(Trim(aFields[i,4])) == (xdata)->(OrdSetFocus())
            cPrompt := aFields[i,5]
            EXIT
         endif
      else
         if Upper(Trim(aFields[i,4])) == xData:OrdSetFocus()
            cPrompt := aFields[i,5]
            EXIT
         endif
      endif
  ELSEIF Valtype(aFields[i,1]) = 'B' .AND. Valtype(aFields[i,4]) = 'N'
      if nDataSourceType = BROWSE_DATABASE               // J. Duijf 27-11-2002
         if aFields[i,4] == (xdata)->(IndexOrd())
            cPrompt := aFields[i,5]
            EXIT
         endif
      else
         if Upper(Trim(aFields[i,4])) == xData:IndexOrd()
            cPrompt := aFields[i,5]
            EXIT
         endif
      endif
      EXIT
  ELSEIF Valtype(aFields[i,1]) = 'N' .AND. Valtype(aFields[i,5]) = 'C'
     cPrompt := aFields[i,5]
     EXIT
  ENDIF
NEXT
aData[3] := .t.  // start-up flag
IF lAutoSeek
  cSeek := Space(50)
  @ nRow, nCol DCSAY DC_LangMsg(DCMSG_FIND_SEEK) GET cSeek SAYRIGHT PICT '@!' ;
    POPUP bPopUp ;
    GETSIZE 25*IIF(lPixel,7,1) ;
    GETTOOLTIP DC_LangMsg(DCMSG_FIND_TOOLTIP) ;
    GETOBJECT aData[4] ;
    LOSTFOCUS {|| cSeek := "",aData[4]:setdata(), aData[4]:Keyboard(xbeK_HOME) } ;
    KEYBLOCK {|a,b,o|DC_BrowseAutoSeek(a,o,aData[1],xData, ;
                     nColumn,cPrefix,bFormat,nDelay,bSeek,@nPointer)}

  @ nRow + IIF(lPixel,4,.2), 34*IIF(lPixel,7,1) + ;
       IIF( Valtype(bPopUp)='B',4*IIF(lPixel,7,1),0) DCSAY cPrompt ;
          SAYSIZE 30*IIF(lPixel,7,1) SAYFONT cSayIndexFont ;
    SAYOBJECT oSeekSay
ENDIF

IF Valtype(aPres) # 'A'
  IF !lHeaders
    aPresentation := { { XBP_PP_COL_HA_HEIGHT, 0 }, ;
                       { XBP_PP_COL_DA_FGCLR, GRA_CLR_BLACK }, ;
                       { XBP_PP_COL_DA_BGCLR, GRA_CLR_WHITE }, ;
                       { XBP_PP_COL_HA_FGCLR, GRA_CLR_WHITE }, ;
                       { XBP_PP_COL_HA_BGCLR, GRA_CLR_DARKGRAY } }
  ELSE
    aPresentation := { { XBP_PP_COL_DA_FGCLR, GRA_CLR_BLACK }, ;
                       { XBP_PP_COL_DA_BGCLR, GRA_CLR_WHITE }, ;
                       { XBP_PP_COL_HA_FGCLR, GRA_CLR_WHITE }, ;
                       { XBP_PP_COL_HA_BGCLR, GRA_CLR_DARKGRAY } }
  ENDIF
  aHeaderColors := { GRA_CLR_DARKGRAY, GRA_CLR_RED }
ELSE
  aPresentation := aPres[1]
  IF Valtype(aPres[2]) # 'A'
    aHeaderColors := { GRA_CLR_DARKGRAY, GRA_CLR_RED }
  ELSE
    aHeaderColors := aPres[2]
  ENDIF
ENDIF

@ nRow + IIF(lAutoSeek,1.5*IIF(lPixel,20,1),0), nCol DCBROWSE aData[1] ;
     DATA xData ELEMENT nPointer ;
     SIZE nWidth, nHeight ;
     HEADLINES nHeadLines ;
     FONT cFont ;
     _FIT !lHorizScroll ;
     POINTER nPointer ;
     SORTSCOLOR aSort[1], aSort[2] ;
     SORTUCOLOR aSort[3], aSort[4] ;
     SORTUPBITMAP aSort[5] ;
     SORTDOWNBITMAP aSort[6] ;
     _SCOPE (lScope .OR. lThumbLock) ;
     THUMBLOCK IIF( lThumbLock,1,100000000 ) ;
     ITEMMARKED bItemMarked ;
     EVAL {|o|o:itemSelected := bItemSelected, ;
              IIF( !lHeaders .OR. !lHorizScroll, o:HScroll := .f. , nil ), ;
              IIF( !lHeaders .OR. !lHorizScroll, o:sizeCols := .f., nil ), ;
              IIF( !lVertSCroll, o:VScroll := .f., nil ), ;
              IIF( !lHeaders .OR. !lHorizScroll .OR. !lVertScroll, o:configure(), nil ) } ;
     PRESENTATION aPresentation

// aFields[i,1]  -  Column Code Block, example {||CUSTOMER->name}
// aFields[i,2]  -  Column Header, example "Customer Name"
// aFields[i,3]  -  Column Width, example 10
// aFields[i,4]  -  Column Index, example "CUSTNAME"
// aFields[i,5]  -  Index Description, example "Customer Name"
// aFields[i,6]  -  Seek Prefix, example "10001"
// aFields[i,7]  -  Seek Format codeblock, ;
//                  example {||Right(Space(7)+Alltrim(cString),7)}
// aFields[i,8]  -  Column Picture clause

aData[2] := Array(LEN(aFields))

FOR i := 1 TO LEN(aFields)
   ASize(aFields[i],8)
   bSort := _SortBlock( aFields, i, @oSeekSay, @cSeek, @aData[4], ;
                        xData, @nColumn, aData, aHeaderColors, ;
                        @cPrefix, @bFormat, nHeadLines, @bSeek )
   IF Valtype(xData) # 'A'
      if nDataSourceType     = BROWSE_DATABASE               // J. Duijf 27-11-2002
         IF (Valtype(aFields[i,4]) == 'C' .AND. aFields[i,4] == (xData)->(OrdSetFocus())) .OR. ;
            (Valtype(aFields[i,4]) == 'N' .AND. aFields[i,4] == (xdata)->(IndexOrd()) ) .AND. nColumn == 0
            nColumn := i
            cPrefix := aFields[i,6]
            bFormat := aFields[i,7]
         ENDIF
      elseif nDataSourceType     = BROWSE_DATAOBJECT             // J. Duijf 27-11-2002
         IF (Valtype(aFields[i,4]) == 'C' .AND. aFields[i,4] == xData:OrdSetFocus()) .OR. ;
            (Valtype(aFields[i,4]) == 'N' .AND. aFields[i,4] == xData:IndexOrd()   ) .AND. nColumn == 0
            nColumn := i
            cPrefix := aFields[i,6]
            bFormat := aFields[i,7]
         ENDIF
      endif
   ELSEIF i = 1
     bSeek := aFields[i,7]
   ENDIF

   IF nColumn == 0
     nColumn := 1
   ENDIF

//   IF Valtype(aFields[i,1]) = 'B' .AND. Valtype(xData) = 'C'
   IF Valtype(aFields[i,1]) = 'B' .AND. Valtype(xData) $ 'CO'              // J. Duijf 27-11-2002
     DCBROWSECOL DATA aFields[i,1] HEADER aFields[i,2] WIDTH aFields[i,3] ;
        PICTURE aFields[i,8] ;
        SORT bSort _LEFTBUTTON lLeftButton ;
        PARENT aData[1] OBJECT aData[2,i]
   ELSEIF Valtype(aFields[i,1]) $ 'NB'
     IF Valtype(aFields[i,1]) = 'B'
       nElement := Eval(aFields[i,1])
     ELSE
       nElement := aFields[i,1]
     ENDIF

     DCBROWSECOL ELEMENT nElement HEADER IIF( lHeaders,aFields[i,2],nil) ;
        WIDTH aFields[i,3] ;
        PICTURE aFields[i,8] ;
        SORT bSort _LEFTBUTTON lLeftButton ;
        PARENT aData[1] OBJECT aData[2,i]
   ENDIF
NEXT

IF lPixel
  DCGETOPTIONS ;
    HILITEGETS aSort[9] ;
    PIXEL ;
    NOBUSY ;
    NOMINBUTTON ;
    NOMAXBUTTON ;
    TABSTOP ;
    _HIDE Empty(oParent)
ELSE
  DCGETOPTIONS ;
    HILITEGETS aSort[9] ;
    NOBUSY ;
    NOMINBUTTON ;
    NOMAXBUTTON ;
    TABSTOP ;
    WINDOWHEIGHT 800 ;
    WINDOWWIDTH 800 ;
    _HIDE Empty(oParent)
ENDIF

DEFAULT bEval := {||nil}


IF lExit
  DCREAD GUI ;
     EXPRESS ;
     TITLE cTitle ;
     OPTIONS GetOptions ;
     SAVE ;
     PARENT @oParent ;
     HANDLER _Handler REFERENCE aData ;
     EVAL {|o|Eval(bEval,o,@aData[1],@aData[4]), ;
              o:resize := {|a,b,c|_Resize(a,b,c,aData,oSeekSay)}, ;
              _HeaderColor(aData,nColumn,aHeaderColors,nHeadLines, ;
                           !Empty(aFields[1,4]),lLeftButton)} ;
     SETFOCUS aData[1] ;
     EXIT ;
     FIT
ELSEIF Valtype(oParent) = 'O'
  DCREAD GUI ;
     EXPRESS ;
     TITLE cTitle ;
     OPTIONS GetOptions ;
     TO lOk ;
     ;// MODAL ;
     SAVE ;
     PARENT @oParent ;
     HANDLER _Handler REFERENCE aData ;
     EVAL {|o|aData[5] := oParent, Eval(bEval,o,@aData[1],@aData[4]), ;
              o:resize := {|a,b,c|_Resize(a,b,c,aData,oSeekSay,oParent)}, ;
              IIF( DC_GetComboMode()==1, ;
                aData[1]:getColumn(1):dataArea:lbUp:=aData[1]:ItemSelected,nil), ;
              IIF(!Empty(nKey),DC_BrowseAutoSeek(nKey,oGet,aData[1],acbData),nil)} ;
     SETFOCUS @aData[4] ;
     _CLEAREVENTS lClearEvents // << needed to make DCGET COMBO VALID work

ELSE

  DCREAD GUI ;
     EXPRESS ;
     FIT ;
     ADDBUTTONS ;
     TITLE cTitle ;
     OPTIONS GetOptions ;
     TO lOk ;
     MODAL ;
     SAVE ;
     EVAL {|o|Eval(bEval,o,@aData[1],@aData[4]),;
              o:resize := {|a,b,c|_Resize(a,b,c,aData,oSeekSay)}, ;
              _HeaderColor(aData,nColumn,aHeaderColors,nHeadLines, ;
                           !Empty(aFields[1,4]),lLeftButton), o:show(), ;
              o:invalidateRect() } ;
     SETFOCUS @aData[4] ;
     _CLEAREVENTS lClearEvents // << needed to make DCGET COMBO VALID work

ENDIF

IF !lExit

  IF !lOk .AND. nSaveRec >= 0 .AND. Empty(bItemMarked)
    IF nDataSourceType     = BROWSE_DATABASE
      DbGoto(nSaveRec)
    ELSEIF nDataSourceType     = BROWSE_DATAOBJECT
      xData:DbGoto(nSaveRec)
    ENDIF
  ENDIF

  DC_GetDestroy(GetList)
  IF nSaveOrder >= 0
     if nDataSourceType     = BROWSE_DATABASE               // J. Duijf 27-11-2002
        OrdSetFocus(nSaveOrder)
     elseif nDataSourceType     = BROWSE_DATAOBJECT         // J. Duijf 27-11-2002
        xData:OrdSetFocus(nSaveOrder)
     endif
  ENDIF

ENDIF

aGetList := GetList

RETURN lOk

* --------------------

STATIC FUNCTION _ReSize( aOldSize, aNewSize, oDlg, aData, oSeekSay, oParent )

LOCAL oBrowse := aData[1], oGet := aData[4], aChildList, oXbp, i

IF aOldSize[1] <= 30 .OR. aNewSize[1] <= 30
  RETURN nil
ENDIF

IF oDlg:isDerivedFrom('XbpDialog')
  aChildList := oDlg:drawingArea:childList()
ELSEIF oDlg:isDerivedFrom('XbpIWindow')
  aChildList := oDlg:ChildList()
ELSE
  RETURN nil
ENDIF

DEFAULT oParent := oBrowse:setParent()

oBrowse:setSize( {oParent:currentSize()[1]-20, ;
                  oBrowse:currentSize()[2]+(aNewSize[2]-aOldSize[2]) } )

FOR i := 1 TO Len(aChildList)
  oXbp := aChildList[i]
  IF !oXbp:isDerivedFrom('XbpBrowse') .AND. !oXbp:isDerivedFrom('XbpPushButton')
    oXbp:setPos( {oXbp:currentPos()[1],oXbp:currentPos()[2]+(aNewSize[2]-aOldSize[2])} )
  ENDIF
NEXT
oDlg:drawingArea:invalidateRect()

RETURN nil

* --------------------

STATIC FUNCTION _Handler( nEvent, mp1, mp2, oXbp, oDlg, GetList, aData, lOk )

LOCAL oBrowse := aData[1], oParent := aData[5], lStartUpFlag := aData[3], ;
      aColumns := aData[2], oSeekGet := aData[4]

IF nEvent == xbeP_Keyboard .AND. mp1 == xbeK_ESC
  RETURN DCGUI_EXIT_ABORT
ELSEIF !lStartupFlag .AND. nEvent == xbeP_Keyboard .AND. ;
       !oXbp:isDerivedFrom('XbpBrowse') .AND. ;
       (oBrowse == SetAppFocus() .OR. aColumns[1] == SetAppFocus())
  // fixes bug in which keyboard events are not received by Browse object
  oBrowse:handleEvent(nEvent, mp1, mp2 )
  RETURN DCGUI_IGNORE
ELSEIF lStartupFlag
  IF Valtype(oSeekGet) # 'O'
    SetAppFocus(oBrowse)
    SetAppFocus(oBrowse:getColumn(1))
  ELSE
    SetAppFocus(oSeekGet)
  ENDIF
  oBrowse:tofront()
  lStartupFlag := .f.
ELSEIF Valtype(oXbp)='O' .AND. nEvent = xbeM_LbDown .AND. ;
       Valtype(oSeekGet) # 'O' .AND. ;
       !(oXbp:setParent()==oBrowse) .AND. ;
       AScan(aColumns,{|x|oXbp:setParent()==x}) = 0
   RETURN DCGUI_EXIT_ABORT
ENDIF
aData[3] := lStartupFlag
RETURN DCGUI_NONE

* --------------------

STATIC FUNCTION _SortBlock( aFields, i, oSeekSay, cSeek, oSeek, xData, nColumn, ;
                            aData, aHeaderColors, cPrefix, bFormat, nHeadLines, ;
                            bSeek )

LOCAL bSort, aUnSelected, aSelected, bBlock, oColumn, nDataSourceType, nSortCol

IF Empty(aFields[i,4]) .OR. Empty(aFields[i,5])
  RETURN {||DC_WinAlert(DC_LangMsg(DCMSG_FIND_NOINDEX)),.f.}
ENDIF

IF Valtype(xData) = 'C'
  nDataSourceType     := BROWSE_DATABASE               // J. Duijf 27-11-2002
ELSEIF Valtype(xData) = "O"
  if xData:isDerivedFrom("SQLStatement")              // J. Duijf 27-11-2002
     nDataSourceType  := BROWSE_DATABASE               // J. Duijf 27-11-2002
  else
     nDataSourceType  := BROWSE_DATAOBJECT             // J. Duijf 27-11-2002
  endif
ENDIF

IF Valtype(xData) = 'A'
  bSort := {|a,n,o,b|nColumn:=n, ;
             cPrefix := aFields[nColumn,6], ;
             bFormat := aFields[nColumn,7], ;
             bSeek := aFields[nColumn,7], ;
             nSortCol := iif(valtype(aFields[nColumn,4])=="N",aFields[nColumn,4],nColumn), ; // S.Elias 7-1-2004
             b := aFields[i,4], ;
             IIF(Valtype(b)='B', ;
               Eval(b),ASort( xData,,,{|x,y|x[nSortCol]<y[nSortCol]} )), ; // S.Elias 7-1-2004
             _SortSay( aFields, i, @oSeekSay, @cSeek, @oSeek, ;
             _HeaderColor(aData,nColumn,aHeaderColors,nHeadlines,.f.) ) }
ELSE
  if nDataSourceType = BROWSE_DATABASE
      bSort := {|a,n,o|nColumn:=n, ;
                  cPrefix := aFields[nColumn,6], ;
                  bFormat := aFields[nColumn,7], ;
                  bSeek := aFields[nColumn,8], ;
                  (xData)->(OrdSetFocus(aFields[i,4])), ;
                  _SortSay( aFields, i, @oSeekSay, @cSeek, @oSeek, ;
                  _HeaderColor(aData,nColumn,aHeaderColors,nHeadlines,.f.) ) }
  endif
  if nDataSourceType = BROWSE_DATAOBJECT
      bSort := {|a,n,o|nColumn:=n, ;
                  cPrefix := aFields[nColumn,6], ;
                  bFormat := aFields[nColumn,7], ;
                  bSeek := aFields[nColumn,8], ;
                  xData:OrdSetFocus(aFields[i,4]), ;
                  _SortSay( aFields, i, @oSeekSay, @cSeek, @oSeek, ;
                  _HeaderColor(aData,nColumn,aHeaderColors,nHeadlines,.f.) ) }
  endif
ENDIF

RETURN bSort

* --------------------

STATIC FUNCTION _HeaderColor( aData, nColumn, aHeaderColors, nHeadLines, ;
                              lStartUp, lLeftButton )

LOCAL i, j, oColumn, bBlock, oBrowse := aData[1]

IF lStartUp
  oColumn := oBrowse:GetColumn(nColumn)
  IF lLeftButton
    PostAppEvent(xbeM_LbDown,{0,0},,oColumn:heading)
  ELSE
    PostAppEvent(xbeM_RbDown,{0,0},,oColumn:heading)
  ENDIF
ENDIF

RETURN nil

* ---------------------

STATIC FUNCTION _SortSay( aFields, i, oSeekSay, cSeek, oSeek )

IF Valtype(oSeekSay) = 'O'
  oSeekSay:SetCaption(aFields[i,5])
  cSeek := Space(20)
  oSeek:setData()
  oSeek:keyboard(xbeK_HOME)
  SetAppFocus(oSeek)
ENDIF

RETURN nil

* ---------------------

FUNCTION DC_BrowseAutoSeek( nKey, oGet, oBrowse, xData, nColumn, ;
                            bcPrefix, bFormat, nDelay, bSeek, nPointer, ;
                            lClearGet, lSeekLast, bScan )

LOCAL nElement, cPrefix, cBuffer, mp1, mp2, oXbp, nSeconds, nEvent, ;
      lGoHome, nRecNo, nDataSourceType, cAlias, cIndexKey, xKeyVal, ;
      nSortColumn

STATIC slIsRunning := .F., ;
       snSeconds := 0

IF Valtype(oBrowse) # 'O' .OR. Valtype(oGet) # 'O'
  RETURN nil
ENDIF

IF SetAppFocus() # oGet .OR. !oGet:isVisible() .OR. slIsRunning
  snSeconds := Seconds()
  IF !(nKey $ {xbeK_ENTER, xbeK_END})
    RETURN nil
  ENDIF
ENDIF

DEFAULT nDelay := .3, ;
        lClearGET := .t.

IF nDelay == 0
  nDelay := .01
ENDIF

lGoHome := .t.

snSeconds := Seconds()
slIsRunning := .T.

/*
IF nDelay > 0
  DO WHILE Seconds() - nSeconds < nDelay .AND. nKey < 60000 .AND. nKey # xbeK_ENTER
    nEvent := DC_NextAppEvent( @mp1, @mp2, @oXbp )
    IF (nEvent = xbeP_Keyboard .AND. oXbp = oGet) .OR. Seconds() < nSeconds
      RETURN nil
    ELSE
      nEvent := AppEvent(@mp1,@mp2,@oXbp,.1)
      IF Valtype(oXbp) == 'O' // .AND. nEvent # xbeP_Keyboard
        oXbp:handleEvent(nEvent,mp1,mp2)
      ENDIF
    ENDIF
  ENDDO
ENDIF
*/

IF nDelay > 0
  DO WHILE Seconds() - snSeconds < nDelay .AND. nKey < 60000 .AND. nKey # xbeK_ENTER
    nEvent := AppEvent(@mp1,@mp2,@oXbp,.1)
    IF Valtype(oXbp) == 'O'
      oXbp:handleEvent(nEvent,mp1,mp2)
    ENDIF
  ENDDO
ENDIF

IF Valtype(xData) $ 'CU'
  nDataSourceType     := BROWSE_DATABASE               // J. Duijf 27-11-2002
  IF Valtype(xData) == 'C'
    cAlias := xData
  ELSE
    cAlias := Alias()
  ENDIF
ELSEIF Valtype(xData) = "O"
  if xData:isDerivedFrom("SQLStatement") .OR. xData:isDerivedFrom("SQLDataSet") // J. Duijf 27-11-2002
     nDataSourceType  := BROWSE_SQLEXPRESS             // J. Duijf 27-11-2002
  elseif xData:isDerivedFrom("dsACEServer")
     nDataSourceType := BROWSE_ACESERVER
  else
     nDataSourceType := BROWSE_DATAOBJECT              // J. Duijf 27-11-2002
  endif
ENDIF

cBuffer := Trim(oGet:editBuffer())

IF Valtype(bFormat) = 'B' .AND. Valtype(xData)#'A'
  cBuffer := Eval(bFormat,cBuffer)
ENDIF

IF Valtype(bcPrefix) = 'B'
  cPrefix := Eval(bcPrefix,cBuffer)
ELSE
  cPrefix := bcPrefix
ENDIF
DEFAULT cPrefix := ''

BEGIN SEQUENCE

do case
  case nKey == xbeK_UP
    oBrowse:up()
    oBrowse:refreshAll()
  case nKey == xbeK_DOWN
    oBrowse:down()
    oBrowse:refreshAll()
  case nKey == xbeK_CTRL_PGUP
    oBrowse:gotop()
    oBrowse:refreshAll()
  case nKey == xbeK_CTRL_PGDN
    oBrowse:gobottom()
    oBrowse:refreshAll()
  case nKey == xbeK_PGDN
    oBrowse:PageDown()
    oBrowse:refreshAll()
  case nKey == xbeK_PGUP
    oBrowse:PageUp()
    oBrowse:refreshAll()
  case Empty(cBuffer) .AND. !nKey == xbeK_ENTER
    BREAK
  case empty(cBuffer) .AND. nkey== xbeK_ENTER
    PostAppEvent(xbeBRW_ItemSelected,nil,nil,oBrowse)
    BREAK
  otherwise
    lGoHome := .f.
    if ( nKey > 31 .and. nKey < 254 ) .or. nKey == xbeK_BS .or. ;
         nKey == xbeK_DEL .OR. nKey == xbeK_ENTER .OR. nKey == xbeK_END
      IF Valtype(xData) = 'A'
        IF Valtype(bSeek)=='B'
          cBuffer := Eval(bSeek,cBuffer)
        ENDIF
        IF Empty(nColumn)
          nSortColumn := oBrowse:sortColumn
          IF nSortColumn > 0
            nColumn := oBrowse:getColumn(nSortColumn):arrayPointer
          ELSE
            nColumn := oBrowse:getColumn(oBrowse:colpos):arrayPointer
          ENDIF
          // nColumn := 1
        ENDIF
        IF Valtype(bScan) == 'B'
          oGet:getData()
          nElement := AScan(xData,bScan)
        ELSE
          nElement := AScan(xData,{|x|LTrim(DC_XtoC(x[nColumn]))=cBuffer})
        ENDIF
        IF nElement > 0
          oBrowse:cargo[4] := nElement
          IF IsMemberVar(oBrowse,'arrayElement')
            oBrowse:arrayElement := nElement
          ENDIF
          oBrowse:refreshAll()
          IF Valtype(bSeek)=='B'
            nPointer := nElement
            Eval(bSeek,cBuffer)
          ENDIF
        ENDIF
      ELSE
         IF nDataSourceType = BROWSE_DATABASE
            IF Valtype(bSeek) = 'B'
               IF Eval(bSeek,IIF( Valtype(cBuffer)="C",cPrefix + cBuffer,cBuffer))
                  IF (cAlias)->(DC_Eof())
                    (cAlias)->(DC_DbGoBottom())
                  ENDIF
                  nRecNo := (cAlias)->(RecNo())
                  IF oBrowse:isDerivedFrom("XbpBrowse")
                    oBrowse:refreshAll()
                    IF nRecNo # (cAlias)->(RecNo())
                      (cAlias)->(dbGoto(nRecNo))
                      oBrowse:refreshAll()
                    ENDIF
                  ELSEIF oBrowse:isDerivedFrom("XbpQuickBrowse")
                    oBrowse:gotoRecord((cAlias)->(RecNo()))
                  ENDIF
               ENDIF
            ELSE
               cIndexKey := (cAlias)->(IndexKey(0))
               IF !Empty(cIndexKey)
                 xKeyVal := (cAlias)->(&(IndexKey(0)))
                 IF Valtype(cBuffer) == 'C' .AND. Valtype(xKeyVal) == 'N'
                   (cAlias)->(DC_DbSeek(Val(cBuffer),.t.,,lSeekLast))
                 ELSE
                   (cAlias)->(DC_DbSeek(IIF( Valtype(cBuffer)="C",cPrefix + cBuffer,cBuffer),.t.,,lSeekLast))
                 ENDIF
               ENDIF
               IF (cAlias)->(DC_Eof())
                 (cAlias)->(DC_DbGoBottom())
               ENDIF
               nRecNo := (cAlias)->(RecNo())
               If oBrowse:isDerivedFrom("XbpBrowse")
                 oBrowse:refreshAll()
                 IF nRecNo # (cAlias)->(RecNo())
                   (cAlias)->(dbGoto(nRecNo))
                   oBrowse:refreshAll()
                 ENDIF
               ELSEIF oBrowse:isDerivedFrom("XbpQuickBrowse")
                 oBrowse:gotoRecord((cAlias)->(RecNo()))
               ENDIF
            ENDIF
         ELSEIF nDataSourceType = BROWSE_DATAOBJECT
            IF Valtype(bSeek) = 'B'
               IF Eval(bSeek,IIF( Valtype(cBuffer)="C",cPrefix + cBuffer,cBuffer))
                  nRecNo := xData:RecNo()
                  oBrowse:refreshAll()
                  IF nRecNo # xdata:RecNo()
                    xdata:Dbgoto(nRecNo)
                    oBrowse:refreshAll()
                  ENDIF
               ENDIF
            ELSE
               xData:DbSeek(IIF( Valtype(cBuffer)="C",cPrefix + cBuffer,cBuffer),.t.)
               nRecNo := xData:RecNo()
               oBrowse:refreshAll()
               IF nRecNo # xData:RecNo()
                 xdata:Dbgoto(nRecNo)
                 oBrowse:refreshAll()
               ENDIF
            ENDIF
         ELSEIF nDataSourceType = BROWSE_SQLEXPRESS
            IF Valtype(bSeek) = 'B'
               IF Eval(bSeek,IIF( Valtype(cBuffer)="C",cPrefix + cBuffer,cBuffer))
                  nRecNo := xData:RecNo()
                  oBrowse:refreshAll()
                  IF nRecNo # xdata:RecNo()
                    xdata:goto(nRecNo)
                    oBrowse:refreshAll()
                  ENDIF
               ENDIF
            ELSE
               xData:Seek(IIF( Valtype(cBuffer)="C",cPrefix + cBuffer,cBuffer),,.t.)
               nRecNo := xData:RecNo()
               oBrowse:refreshAll()
               IF nRecNo # xData:RecNo()
                 xdata:goto(nRecNo)
                 oBrowse:refreshAll()
               ENDIF
            ENDIF
         ELSEIF nDataSourceType = BROWSE_ACESERVER
            IF Valtype(bSeek) = 'B'
               IF Eval(bSeek,IIF( Valtype(cBuffer)="C",cPrefix + cBuffer,cBuffer))
                  nRecNo := xData:RecNo()
                  oBrowse:refreshAll()
                  IF nRecNo # xdata:RecNo()
                    xdata:GoTo(nRecNo)
                    oBrowse:refreshAll()
                  ENDIF
               ENDIF
            ELSE
               xData:DbSeek(IIF( Valtype(cBuffer)="C",cPrefix + cBuffer,cBuffer),.t.)
               nRecNo := xData:RecNo()
               oBrowse:refreshAll()
               IF nRecNo # xData:RecNo()
                 xdata:GoTo(nRecNo)
                 oBrowse:refreshAll()
               ENDIF
            ENDIF
          ENDIF
       ENDIF
    ENDIF
    IF nKey == xbeK_ENTER
      IF lClearGET
        lGoHome := .t.
      ENDIF
      PostAppEvent(xbeBRW_ItemSelected,nil,nil,oBrowse)
    ENDIF

endcase

IF lGoHome
  IF oGet:isDerivedFrom('DC_XbpGet')
    oGet:get:home()
    IF lClearGet
      oGet:setdata()
    ENDIF
  ELSEIF oGet:isDerivedFrom('XbpSle')
    oGet:home()
    IF lClearGet
      oGet:setdata()
    ENDIF
  ENDIF
ENDIF

IF oBrowse:isDerivedFrom("DC_XbpBrowse")
  nPointer := oBrowse:cargo[4]
ENDIF

END SEQUENCE

slIsRunning := .F.

RETURN nil

* -----------------

FUNCTION DC_GetComboMode( nMode )

STATIC snMode := 0

LOCAL nOldMode := snMode

IF Valtype(nMode) == 'N'
  snMode := nMode
ENDIF

RETURN nOldMode

* -----------------

FUNCTION DC_FindBrowseSort( aSort )

STATIC saSort := { GRA_CLR_WHITE, ;     // Sort Selected Color (Foreground)
                   GRA_CLR_RED, ;       // Sort Selected Color (Background)
                   GRA_CLR_WHITE, ;     // Sort Non-Selectable Color (Foreground)
                   GRA_CLR_DARKGRAY, ;  // Sort Non-Selectable Color (Background)
                   nil, ;               // Sort UP Bitmap (No longer used)
                   nil, ;               // Sort DOWN Bitmap (No longer used)
                   GRA_CLR_WHITE, ;     // Sort Un-Selected Color (Foreground)
                   GRA_CLR_BLUE, ;      // Sort Un-Selected Color (Background)
                   GRA_CLR_RED }        // Color around search box and browse

LOCAL aOldSort := saSort

IF Valtype(aSort) = 'A'
  saSort := aSort
ENDIF

DEFAULT aOldSort := {}
ASize(aOldSort,9)

RETURN aOldSort

